package edu.cmu.paid.authentication;

import java.util.*;
import edu.cmu.paid.database.storage.*;
import edu.cmu.paid.authentication.util.ByteConverterWrapper;
import edu.cmu.paid.authentication.Exception.*;


public class MakeUsers {

  public static void main(String args[]) {
    Group g1,g2,g3;
    User u1,u2,u3,u4;

    g1 = new Group(1,"Group 1");
    g2 = new Group(2,"Group 2");
    g3 = new Group(3,"Group 3");

  
    Vector acc1,acc2;

    acc1 = new Vector(5);
    acc2 = new Vector(3);

    acc1.addElement(new Integer(Authentication.PARTS_APPID));
    acc1.addElement(new Integer(Authentication.CUSTOMER_APPID));
    acc1.addElement(new Integer(Authentication.DEALERADMIN_APPID));
    acc1.addElement(new Integer(Authentication.DOWNLOADMGMT_APPID));
    acc1.addElement(new Integer(Authentication.UPDATEMGMT_APPID));

    acc2.addElement(new Integer(Authentication.PARTS_APPID));
    acc2.addElement(new Integer(Authentication.CUSTOMER_APPID));
    acc2.addElement(new Integer(Authentication.UPDATEMGMT_APPID));

    try {
      g1.setAccessibleWindows(acc1);
      g2.setAccessibleWindows(acc1);
      g3.setAccessibleWindows(acc2);
    }
    catch (AccessAlreadyExistsException e) {
      System.out.println("Group access already set! Failing.");
      return;
    }
    finally {
      System.out.println("");
    }

    AuthData.initAuthData();
    System.out.println("Database initialized... Beginning to add groups...");
  
    byte [] serG1,serG2,serG3;
    serG1 = ByteConverterWrapper.toByteArray(g1);
    serG2 = ByteConverterWrapper.toByteArray(g2);
    serG3 = ByteConverterWrapper.toByteArray(g3);

    AuthData.addGroupProfile(g1.getGroupID(),serG1);
    AuthData.addGroupProfile(g2.getGroupID(),serG2);
    AuthData.addGroupProfile(g3.getGroupID(),serG3);

    System.out.println("Groups have been added to the database.");
    System.out.println("\nCreating users.");

    byte[] k1,k2,k3,k4;

    k1 = ByteConverterWrapper.toByteArray(98980101);
    k2 = ByteConverterWrapper.toByteArray(45452323);
    k3 = ByteConverterWrapper.toByteArray(21216767);
    k4 = ByteConverterWrapper.toByteArray(11001100);
    
    u1 = new User(1,k1,1,"Pooja","Saksena");
    u2 = new User(2,k2,1,"Qiang","Rao");
    u3 = new User(3,k3,1,"David","Garmire");
    u4 = new User(4,k4,2,"Arnaldo","Piccinelli - NonAffiliated");

    u1.assignUserGroup(1);
    u2.assignUserGroup(2);
    u3.assignUserGroup(1);
    u4.assignUserGroup(3);

    System.out.println("Users have been defined. Now trying to insert into database.");

    byte[] u1b, u2b, u3b, u4b;
    u1b = ByteConverterWrapper.toByteArray(u1);
    u2b = ByteConverterWrapper.toByteArray(u2);
    u3b = ByteConverterWrapper.toByteArray(u3);
    u4b = ByteConverterWrapper.toByteArray(u4);

    try {
      AuthData.addUserProfile(u1.getUserID(),u1b);
      AuthData.addUserProfile(u2.getUserID(),u2b);
      AuthData.addUserProfile(u3.getUserID(),u3b);
      AuthData.addUserProfile(u4.getUserID(),u4b);
    }
    catch (NoUserException e) {
      System.out.println("Caught a NoUser Exception.\nDatabase init failed!");
      return;
    }
    finally {
      System.out.println("");
    }

    System.out.println("Users loaded successfully into database.");
    
    return;
  }
}
